#pragma once

#include "CoreMinimal.h"
#include "Firecracker.h"
#include "DBDTunableRowHandle.h"
#include "GameplayTagContainer.h"
#include "EOfferingEffectType.h"
#include "Templates/SubclassOf.h"
#include "Engine/CollisionProfile.h"
#include "SmokeBomb.generated.h"

class UItemModifier;
class UStatusEffect;
class ASmokeBombCosmeticHelperActor;
class USmokeBombCosmeticHelperManager;

UCLASS(Blueprintable)
class DBDGAMEPLAY_API ASmokeBomb : public AFirecracker
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	UItemModifier* _itemModifier;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _smokeCloudAreaRadius;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _secondsToExpand;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _secondsAtMaxSize;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _secondsToDisappear;

	UPROPERTY(EditAnywhere)
	FGameplayTag _useSmokeBombScoreEvent;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	EOfferingEffectType _offeringDoublingScore;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _scratchMarkPreventionAreaMinRadius;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _scratchMarkPreventionAreaMaxRadius;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _scratchMarkPreventionStatusEffect;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FCollisionProfileName _playerDetectorCollisionProfileName;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<ASmokeBombCosmeticHelperActor> _smokePlayerCosmeticHelperActorClass;

	UPROPERTY(BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	USmokeBombCosmeticHelperManager* _smokeCosmeticManager;

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void OnSmokeAreaStartedToShrink();

public:
	ASmokeBomb();
};

FORCEINLINE uint32 GetTypeHash(const ASmokeBomb) { return 0; }
